#!/usr/bin/env python
# -*- coding: UTF-8 -*-

# reset_sync_settings.py

global moneydance

from java.util import UUID

root = moneydance.getCurrentAccountBook().getRootAccount()
storage = moneydance.getCurrentAccount().getBook().getLocalStorage()

SYNC_KEYS = ["netsync.dropbox.fileid",
             "netsync.sync_type",
             "netsync.subpath",
             "netsync.dropbox_enabled",
             "netsync.synckey",
             "ext.netsync.settings",
             "netsync.guid",
             "migrated.netsync.dropbox.fileid",
             "migrated.ext.netsync.settings",
             "migrated.netsync.dropbox_enabled",
             "migrated.netsync.guid",
             "migrated.netsync.synckey"
             ]

print "-------"
print "\n\n\nStorage keys before removal...:\n------"
for skey in SYNC_KEYS: print "%s: '%s'" %(skey, storage.get(skey))

print "-------"
print "\n\n\nRoot (legacy) keys before removal...:\n------"
for skey in SYNC_KEYS: print "%s: '%s'" %(skey, root.getParameter(skey))

print "\n-------"
print "Removing sync keys from storage...."
for skey in SYNC_KEYS: storage.remove(skey)                                                                          # noqa

newID = UUID.randomUUID()
print "Loading a new ID for dataset: '%s'" %(newID)
storage.put("netsync.dropbox.fileid", newID)

print "Setting this dataset as a master sync node..."
moneydance.getUI().getCurrentAccounts().setIsMasterSyncNode(True)

print "Saving local storage....."
storage.save()

print "\n-------"
print "Removing legacy root keys....."
root.setEditingMode()
for skey in SYNC_KEYS: root.removeParameter(skey)
root.syncItem()

print "\n-------\n@@@ DONE (Restart MD and setup syncing again).... @@@ "
